#include "opengl.h"
#include "objmesh.h"
#include "snode.h"

ObjMesh::ObjMesh()
{
	mesh = 0;
}

ObjType ObjMesh::get_type() const
{
	return OBJ_MESH;
}

void ObjMesh::draw() const
{
	if(!mesh) return;

	mtl.setup();

	if(node) {
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glMultMatrixf(node->get_matrix()[0]);
	}

	mesh->draw();

	if(node) {
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
	}
}

const AABox &ObjMesh::get_aabox() const
{
	return mesh ? mesh->get_aabbox() : Object::get_aabox();
}
